<?php

/**
 * Implementiert das Einstellen der Provisionierungsparameter
 * @author Miguel Palmer <mp@beronet.com>
 */
class Provisioning {
	/**
	 * Funktion display erzeugt den Inhalt von der HTML-Seite
	 * @return string HTML Seite
	 */
	function display() {
		$name = "PROVISIONING_TITLE_DIS";
		include('./includes/header.php');
		ob_start();
		?>
		<script  type="text/javascript">
		    function show_provopts(ch) {
		        if (!ch) {
		            $('#prov_mode').hide();
		            $('#prov_url').hide();
		            $('#poll_int').hide();
		        } else {
		            $('#prov_mode').show();
		            $('#prov_url').show();
		            $('#poll_int').show();
		        }
		    }
		</script>
		<form name="provisioning" id="provisioning" class="form-horizontal" action="" method="POST">
			<? echo $this->dynamic_table() ?>
			<input type="hidden" name="m" value="<? echo $_GET['m'] ?>">
			<input type="hidden" name="a" value="save">
		</form>
		<script type="text/javascript">
		    show_provopts(document.getElementById("prov_man").checked);
		    $("#provisioning").validate();
		</script>
		<?php
		$ret .= ob_get_clean();

		return $ret;
	}

	/**
	 * Generiert das HTML Formular und speichert die Einstellungen
	 * @return string HTML Formular
	 */

	function dynamic_table() {
		require_once('./includes/lang.php');
		include('/usr/fallback/beroConf.php');

		$bc = new beroConf('root');

		$table = '';
		if ($_POST['action'] == 'save') {
			$bc->set('root', 'provisioning_manual', (isset($_POST['provisioning_manual']) ? '1' : '0'));

			if ($bc->get('root', 'provisioning_manual') == '1') {
				$bc->set('root', 'provisioning_mode', sqlite_escape_string($_POST['provisioning_mode']));
				$bc->set('root', 'provisioning_url', sqlite_escape_string($_POST['provisioning_url']));
				$bc->set('root', 'polling_interval', sqlite_escape_string($_POST['polling_interval']));
			} else {
				$bc->set('root', 'provisioning_mode', 'off');
				$bc->delete('root', 'provisioning_url');
				$bc->delete('root', 'polling_interval');
			}

			$table .= Helper::activate(1, true, $_GET['m'], ACTIVATE);
		}

		if (isset($_POST['deleteMd5'])) {
			$bc->delete('root', 'provisioning_config_md5');
		}

		$selmode = $bc->get('root', 'provisioning_mode');
		ob_start();
		?>
		<p class="text-center lead">
			<? echo PROVISIONING_TABLE_HEADER_DIS ?>
		</p>
		<div class='form-group'>
			<label for='provisioning_manual' class='col-sm-6 control-label'><? echo PROVISIONING_MANUAL_DIS ?></label>
			<div class='col-sm-4'>
				<input type="checkbox" name="provisioning_manual" id="prov_man"  
					   onclick="show_provopts($('#prov_man').prop('checked'));" value="1" 
					   <? echo (($bc->get('root', 'provisioning_manual') == 1) ? ' checked' : '') ?>>
			</div>
		</div>
		<div class='form-group' id="prov_mode">
			<label for='provisioning_mode' class='col-sm-6 control-label'><? echo PROVISIONING_MODE_DIS ?></label>
			<div class='col-sm-4'>
				<select name="provisioning_mode" class="form-control input-sm">
					<? foreach (array('off', 'once', 'always') as $mode): ?>
						<option value="<? echo $mode ?>" <? echo (($mode == $selmode) ? ' selected' : '') ?>><? echo $mode ?></option>
					<? endforeach; ?>
				</select>
			</div>
		</div>
		<div class='form-group' id="prov_url">
			<label for='provisioning_url' class='col-sm-6 control-label'><? echo PROVISIONING_URL_DIS ?></label>
			<div class='col-sm-4'>
				<input type="text" class="form-control input-sm" name="provisioning_url" value="<? echo $bc->get('root', 'provisioning_url') ?>">
			</div>
		</div>
		<div class='form-group' id="poll_int">
			<label for='polling_interval' class='col-sm-6 control-label'><? echo PROVISIONING_POLLING_INTERVAL_DIS ?></label>
			<div class='col-sm-4'>
				<input type="text" class="form-control input-sm" name="polling_interval" digits="true" value="<? echo $bc->get('root', 'polling_interval') ?>" min="0">
			</div>
		</div>

		<br>
		<div class="text-center">
			<input type="hidden" name="action" value="save">
			<input type="submit" name="submit" class="btn btn-default" value="<? echo BUTTON_SAVE ?>">
		</div>
		<?php
		if (strlen(($provConfigMd5 = $bc->get('root', 'provisioning_config_md5'))) == 0) {
			$table .= ob_get_clean();
			return $table;
		}
		?>
		<br>
		<br>
		<p class="text-center lead"><? echo PROVISIONINGMD5_TABLE_HEADER_DIS ?></p>
		<form name="provMd5" action="" method="POST">
			<div class="text-center">
				<input type="submit" name="deleteMd5" class="btn btn-default" value="Delete">
			</div>
		</form>

		<?php
		$table .= ob_clean();

		return($table);
	}

}
?>
